diff -urN avr-libc-orig//configure.ac avr-libc//configure.ac
--- avr-libc-orig//configure.ac	2012-11-29 16:07:06.000000000 -0800
+++ avr-libc//configure.ac	2012-11-30 17:15:41.000000000 -0800
@@ -913,27 +913,46 @@
 CHECK_AVR_DEVICE(atxmega16a4)
 AM_CONDITIONAL(HAS_atxmega16a4, test "x$HAS_atxmega16a4" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega16a4u)
+AM_CONDITIONAL(HAS_atxmega16a4u, test "x$HAS_atxmega16a4u" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega16d4)
 AM_CONDITIONAL(HAS_atxmega16d4, test "x$HAS_atxmega16d4" = "xyes")
 
 CHECK_AVR_DEVICE(atxmega32a4)
 AM_CONDITIONAL(HAS_atxmega32a4, test "x$HAS_atxmega32a4" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega32a4u)
+AM_CONDITIONAL(HAS_atxmega32a4u, test "x$HAS_atxmega32a4u" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega32d4)
 AM_CONDITIONAL(HAS_atxmega32d4, test "x$HAS_atxmega32d4" = "xyes")
 
-
 # avrxmega4
 CHECK_AVR_DEVICE(avrxmega4)
 AM_CONDITIONAL(HAS_avrxmega4, test "x$HAS_avrxmega4" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega64a4)
+AM_CONDITIONAL(HAS_atxmega64a4, test "x$HAS_atxmega64a4" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega64d4)
+AM_CONDITIONAL(HAS_atxmega64d4, test "x$HAS_atxmega64d4" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega64a3)
 AM_CONDITIONAL(HAS_atxmega64a3, test "x$HAS_atxmega64a3" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega64a3u)
+AM_CONDITIONAL(HAS_atxmega64a3u, test "x$HAS_atxmega64a3u" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega64b3)
+AM_CONDITIONAL(HAS_atxmega64b3, test "x$HAS_atxmega64b3" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega64c3)
+AM_CONDITIONAL(HAS_atxmega64c3, test "x$HAS_atxmega64c3" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega64d3)
 AM_CONDITIONAL(HAS_atxmega64d3, test "x$HAS_atxmega64d3" = "xyes")
 
-
 # avrxmega5
 CHECK_AVR_DEVICE(avrxmega5)
 AM_CONDITIONAL(HAS_avrxmega5, test "x$HAS_avrxmega5" = "xyes")
@@ -941,35 +960,69 @@
 CHECK_AVR_DEVICE(atxmega64a1)
 AM_CONDITIONAL(HAS_atxmega64a1, test "x$HAS_atxmega64a1" = "xyes")
 
-CHECK_AVR_DEVICE(atxmega64a1u)
-AM_CONDITIONAL(HAS_atxmega64a1u, test "x$HAS_atxmega64a1u" = "xyes")
-
+CHECK_AVR_DEVICE(atxmega64b1)
+AM_CONDITIONAL(HAS_atxmega64b1, test "x$HAS_atxmega64b1" = "xyes")
 
 # avrxmega6
 CHECK_AVR_DEVICE(avrxmega6)
 AM_CONDITIONAL(HAS_avrxmega6, test "x$HAS_avrxmega6" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega128a4)
+AM_CONDITIONAL(HAS_atxmega128a4, test "x$HAS_atxmega128a4" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega128a4u)
+AM_CONDITIONAL(HAS_atxmega128a4u, test "x$HAS_atxmega128a4u" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega128d4)
+AM_CONDITIONAL(HAS_atxmega128d4, test "x$HAS_atxmega128d4" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega128a3)
 AM_CONDITIONAL(HAS_atxmega128a3, test "x$HAS_atxmega128a3" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega128a3u)
+AM_CONDITIONAL(HAS_atxmega128a3u, test "x$HAS_atxmega128a3u" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega128b3)
+AM_CONDITIONAL(HAS_atxmega128b3, test "x$HAS_atxmega128b3" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega128d3)
 AM_CONDITIONAL(HAS_atxmega128d3, test "x$HAS_atxmega128d3" = "xyes")
 
 CHECK_AVR_DEVICE(atxmega192a3)
 AM_CONDITIONAL(HAS_atxmega192a3, test "x$HAS_atxmega192a3" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega192a3u)
+AM_CONDITIONAL(HAS_atxmega192a3u, test "x$HAS_atxmega192a3u" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega192c3)
+AM_CONDITIONAL(HAS_atxmega192c3, test "x$HAS_atxmega192c3" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega192d3)
 AM_CONDITIONAL(HAS_atxmega192d3, test "x$HAS_atxmega192d3" = "xyes")
 
 CHECK_AVR_DEVICE(atxmega256a3)
 AM_CONDITIONAL(HAS_atxmega256a3, test "x$HAS_atxmega256a3" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega256a3u)
+AM_CONDITIONAL(HAS_atxmega256a3u, test "x$HAS_atxmega256a3u" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega256a3b)
 AM_CONDITIONAL(HAS_atxmega256a3b, test "x$HAS_atxmega256a3b" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega256a3bu)
+AM_CONDITIONAL(HAS_atxmega256a3bu, test "x$HAS_atxmega256a3bu" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega256c3)
+AM_CONDITIONAL(HAS_atxmega256c3, test "x$HAS_atxmega256c3" = "xyes")
+
 CHECK_AVR_DEVICE(atxmega256d3)
 AM_CONDITIONAL(HAS_atxmega256d3, test "x$HAS_atxmega256d3" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega384c3)
+AM_CONDITIONAL(HAS_atxmega384c3, test "x$HAS_atxmega384c3" = "xyes")
+
+CHECK_AVR_DEVICE(atxmega384d3)
+AM_CONDITIONAL(HAS_atxmega384d3, test "x$HAS_atxmega384d3" = "xyes")
 
 # avrxmega7
 CHECK_AVR_DEVICE(avrxmega7)
@@ -981,6 +1034,8 @@
 CHECK_AVR_DEVICE(atxmega128a1u)
 AM_CONDITIONAL(HAS_atxmega128a1u, test "x$HAS_atxmega128a1u" = "xyes")
 
+CHECK_AVR_DEVICE(atxmega128b1)
+AM_CONDITIONAL(HAS_atxmega128b1, test "x$HAS_atxmega128b1" = "xyes")
 
 # avrtiny10
 CHECK_AVR_DEVICE(avrtiny10)
@@ -1296,15 +1351,22 @@
 AC_CONFIG_FILES([
 	avr/lib/avrxmega2/Makefile
 	avr/lib/avrxmega2/atxmega16a4/Makefile
+	avr/lib/avrxmega2/atxmega16a4u/Makefile
 	avr/lib/avrxmega2/atxmega16d4/Makefile
 	avr/lib/avrxmega2/atxmega32a4/Makefile
+	avr/lib/avrxmega2/atxmega32a4u/Makefile
 	avr/lib/avrxmega2/atxmega32d4/Makefile
 ])
 
 # avrxmega4
 AC_CONFIG_FILES([
 	avr/lib/avrxmega4/Makefile
+	avr/lib/avrxmega4/atxmega64a4/Makefile
+	avr/lib/avrxmega4/atxmega64d4/Makefile
 	avr/lib/avrxmega4/atxmega64a3/Makefile
+	avr/lib/avrxmega4/atxmega64a3u/Makefile
+	avr/lib/avrxmega4/atxmega64b3/Makefile
+	avr/lib/avrxmega4/atxmega64c3/Makefile
 	avr/lib/avrxmega4/atxmega64d3/Makefile
 ])
 
@@ -1312,19 +1374,31 @@
 AC_CONFIG_FILES([
 	avr/lib/avrxmega5/Makefile
 	avr/lib/avrxmega5/atxmega64a1/Makefile
-	avr/lib/avrxmega5/atxmega64a1u/Makefile
+	avr/lib/avrxmega5/atxmega64b1/Makefile
 ])
 
 # avrxmega6
 AC_CONFIG_FILES([
 	avr/lib/avrxmega6/Makefile
+	avr/lib/avrxmega6/atxmega128a4/Makefile
+	avr/lib/avrxmega6/atxmega128a4u/Makefile
+	avr/lib/avrxmega6/atxmega128d4/Makefile
 	avr/lib/avrxmega6/atxmega128a3/Makefile
+	avr/lib/avrxmega6/atxmega128a3u/Makefile
+	avr/lib/avrxmega6/atxmega128b3/Makefile
 	avr/lib/avrxmega6/atxmega128d3/Makefile
 	avr/lib/avrxmega6/atxmega192a3/Makefile
+	avr/lib/avrxmega6/atxmega192a3u/Makefile
+	avr/lib/avrxmega6/atxmega192c3/Makefile
 	avr/lib/avrxmega6/atxmega192d3/Makefile
 	avr/lib/avrxmega6/atxmega256a3/Makefile
+	avr/lib/avrxmega6/atxmega256a3u/Makefile
 	avr/lib/avrxmega6/atxmega256a3b/Makefile
+	avr/lib/avrxmega6/atxmega256a3bu/Makefile
+	avr/lib/avrxmega6/atxmega256c3/Makefile
 	avr/lib/avrxmega6/atxmega256d3/Makefile
+	avr/lib/avrxmega6/atxmega384c3/Makefile
+	avr/lib/avrxmega6/atxmega384d3/Makefile
 ])
 
 # avrxmega7
@@ -1332,9 +1406,9 @@
 	avr/lib/avrxmega7/Makefile
 	avr/lib/avrxmega7/atxmega128a1/Makefile
 	avr/lib/avrxmega7/atxmega128a1u/Makefile
+	avr/lib/avrxmega7/atxmega128b1/Makefile
 ])
 
-
 # avrtiny10
 AC_CONFIG_FILES([
 	avr/lib/avrtiny10/Makefile
diff -urN avr-libc-orig//devtools/gen-avr-lib-tree.sh avr-libc//devtools/gen-avr-lib-tree.sh
--- avr-libc-orig//devtools/gen-avr-lib-tree.sh	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//devtools/gen-avr-lib-tree.sh	2012-11-30 17:15:41.000000000 -0800
@@ -285,34 +285,54 @@
 
 AVRXMEGA2_DEV_INFO="\
 atxmega16a4:crtx16a4.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
+atxmega16a4u:crtx16a4u.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 atxmega16d4:crtx16d4.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 atxmega32a4:crtx32a4.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atxmega32d4:crtx32d4.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
+atxmega32a4u:crtx32a4u.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
+atxmega32d4:crtx32d4.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 "
 
 AVRXMEGA4_DEV_INFO="\
+atxmega64a4:crtx64a4.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega64d4:crtx64d4.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega64a3:crtx64a3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
-atxmega64d3:crtx64d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS}\
+atxmega64a3u:crtx64a3u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega64b3:crtx64b3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega64c3:crtx64c3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega64d3:crtx64d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 "
 
 AVRXMEGA5_DEV_INFO="\
 atxmega64a1:crtx64a1.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
-atxmega64a1u:crtx64a1u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS}\
+atxmega64b1:crtx64b1.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 "
 
 AVRXMEGA6_DEV_INFO="\
+atxmega128a4:crtx128a4.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega128a4u:crtx128a4u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega128d4:crtx128d4.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega128a3:crtx128a3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega128a3u:crtx128a3u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega128b3:crtx128b3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega128d3:crtx128d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega192a3:crtx192a3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega192a3u:crtx192a3u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega192c3:crtx192c3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega192d3:crtx192d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega256a3:crtx256a3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega256a3u:crtx256a3u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 atxmega256a3b:crtx256a3b.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
-atxmega256d3:crtx256d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS}\
+atxmega256a3bu:crtx256a3bu.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega256c3:crtx256c3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega256d3:crtx256d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega384c3:crtx384c3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega384d3:crtx384d3.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 "
 
 AVRXMEGA7_DEV_INFO="\
 atxmega128a1:crtx128a1.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
-atxmega128a1u:crtx128a1u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS}\
+atxmega128a1u:crtx128a1u.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
+atxmega128b1:crtx128b1.o:${DEV_DEFS}:${CFLAGS_BIG_MEMORY}:${DEV_ASFLAGS};\
 "
 
 AVRTINY10_DEV_INFO="\
diff -urN avr-libc-orig//include/avr/eeprom.h avr-libc//include/avr/eeprom.h
--- avr-libc-orig//include/avr/eeprom.h	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//include/avr/eeprom.h	2012-11-30 17:15:41.000000000 -0800
@@ -350,39 +350,79 @@
 #elif defined (__AVR_AT90SCR100__)
 # define _EEPROM_SUFFIX _90scr100
 #elif defined (__AVR_ATxmega16A4__)
-# define _EEPROM_SUFFIX   _x16a4
+# define _EEPROM_SUFFIX 16a4
+#elif defined (__AVR_ATxmega16A4U__)
+# define _EEPROM_SUFFIX 16a4u
 #elif defined (__AVR_ATxmega16D4__)
-# define _EEPROM_SUFFIX   _x16d4
+# define _EEPROM_SUFFIX 16d4
 #elif defined (__AVR_ATxmega32A4__)
-# define _EEPROM_SUFFIX   _x32a4
+# define _EEPROM_SUFFIX 32a4
+#elif defined (__AVR_ATxmega32A4U__)
+# define _EEPROM_SUFFIX 32a4u
 #elif defined (__AVR_ATxmega32D4__)
-# define _EEPROM_SUFFIX   _x32d4
-#elif defined (__AVR_ATxmega64A1__)
-# define _EEPROM_SUFFIX   _x64a1
-#elif defined (__AVR_ATxmega64A1U__)
-# define _EEPROM_SUFFIX   _x64a1u
+# define _EEPROM_SUFFIX 32d4
+#elif defined (__AVR_ATxmega64A4__)
+# define _EEPROM_SUFFIX 64a4
+#elif defined (__AVR_ATxmega64D4__)
+# define _EEPROM_SUFFIX 64d4
 #elif defined (__AVR_ATxmega64A3__)
-# define _EEPROM_SUFFIX   _x64a3
+# define _EEPROM_SUFFIX 64a3
+#elif defined (__AVR_ATxmega64A3U__)
+# define _EEPROM_SUFFIX 64a3u
+#elif defined (__AVR_ATxmega64B3__)
+# define _EEPROM_SUFFIX 64b3
+#elif defined (__AVR_ATxmega64C3__)
+# define _EEPROM_SUFFIX 64c3
 #elif defined (__AVR_ATxmega64D3__)
-# define _EEPROM_SUFFIX   _x64d3
-#elif defined (__AVR_ATxmega128A1__)
-# define _EEPROM_SUFFIX   _x128a1
-#elif defined (__AVR_ATxmega128A1U__)
-# define _EEPROM_SUFFIX   _x128a1u
+# define _EEPROM_SUFFIX 64d3
+#elif defined (__AVR_ATxmega64A1__)
+# define _EEPROM_SUFFIX 64a1
+#elif defined (__AVR_ATxmega64B1__)
+# define _EEPROM_SUFFIX 64b1
+#elif defined (__AVR_ATxmega128A4__)
+# define _EEPROM_SUFFIX 128a4
+#elif defined (__AVR_ATxmega128A4U__)
+# define _EEPROM_SUFFIX 128a4u
+#elif defined (__AVR_ATxmega128D4__)
+# define _EEPROM_SUFFIX 128d4
 #elif defined (__AVR_ATxmega128A3__)
-# define _EEPROM_SUFFIX   _x128a3
+# define _EEPROM_SUFFIX 128a3
+#elif defined (__AVR_ATxmega128A3U__)
+# define _EEPROM_SUFFIX 128a3u
+#elif defined (__AVR_ATxmega128B3__)
+# define _EEPROM_SUFFIX 128b3
 #elif defined (__AVR_ATxmega128D3__)
-# define _EEPROM_SUFFIX   _x128d3
+# define _EEPROM_SUFFIX 128d3
 #elif defined (__AVR_ATxmega192A3__)
-# define _EEPROM_SUFFIX   _x192a3
+# define _EEPROM_SUFFIX 192a3
+#elif defined (__AVR_ATxmega192A3U__)
+# define _EEPROM_SUFFIX 192a3u
+#elif defined (__AVR_ATxmega192C3__)
+# define _EEPROM_SUFFIX 192c3
 #elif defined (__AVR_ATxmega192D3__)
-# define _EEPROM_SUFFIX   _x192d3
+# define _EEPROM_SUFFIX 192d3
 #elif defined (__AVR_ATxmega256A3__)
-# define _EEPROM_SUFFIX   _x256a3
+# define _EEPROM_SUFFIX 256a3
+#elif defined (__AVR_ATxmega256A3U__)
+# define _EEPROM_SUFFIX 256a3u
 #elif defined (__AVR_ATxmega256A3B__)
-# define _EEPROM_SUFFIX   _x256a3b
+# define _EEPROM_SUFFIX 256a3b
+#elif defined (__AVR_ATxmega256A3BU__)
+# define _EEPROM_SUFFIX 256a3bu
+#elif defined (__AVR_ATxmega256C3__)
+# define _EEPROM_SUFFIX 256c3
 #elif defined (__AVR_ATxmega256D3__)
-# define _EEPROM_SUFFIX   _x256d3
+# define _EEPROM_SUFFIX 256d3
+#elif defined (__AVR_ATxmega384C3__)
+# define _EEPROM_SUFFIX 384c3
+#elif defined (__AVR_ATxmega384D3__)
+# define _EEPROM_SUFFIX 384d3
+#elif defined (__AVR_ATxmega128A1__)
+# define _EEPROM_SUFFIX 128a1
+#elif defined (__AVR_ATxmega128A1U__)
+# define _EEPROM_SUFFIX 128a1u
+#elif defined (__AVR_ATxmega128B1__)
+# define _EEPROM_SUFFIX 128b1
 #elif defined (__AVR_ATA6289__)
 # define _EEPROM_SUFFIX _a6289
 /* avr1: the following only supported for assembler programs */
diff -urN avr-libc-orig//include/avr/io.h avr-libc//include/avr/io.h
--- avr-libc-orig//include/avr/io.h	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//include/avr/io.h	2012-11-30 17:15:41.000000000 -0800
@@ -376,38 +376,78 @@
 #  include <avr/io90scr100.h>
 #elif defined (__AVR_ATxmega16A4__)
 #  include <avr/iox16a4.h>
+#elif defined (__AVR_ATxmega16A4U__)
+#  include <avr/iox16a4u.h>
 #elif defined (__AVR_ATxmega16D4__)
 #  include <avr/iox16d4.h>
 #elif defined (__AVR_ATxmega32A4__)
 #  include <avr/iox32a4.h>
+#elif defined (__AVR_ATxmega32A4U__)
+#  include <avr/iox32a4u.h>
 #elif defined (__AVR_ATxmega32D4__)
 #  include <avr/iox32d4.h>
-#elif defined (__AVR_ATxmega64A1__)
-#  include <avr/iox64a1.h>
-#elif defined (__AVR_ATxmega64A1U__)
-#  include <avr/iox64a1u.h>
+#elif defined (__AVR_ATxmega64A4__)
+#  include <avr/iox64a4.h>
+#elif defined (__AVR_ATxmega64D4__)
+#  include <avr/iox64d4.h>
 #elif defined (__AVR_ATxmega64A3__)
 #  include <avr/iox64a3.h>
+#elif defined (__AVR_ATxmega64A3U__)
+#  include <avr/iox64a3u.h>
+#elif defined (__AVR_ATxmega64B3__)
+#  include <avr/iox64b3.h>
+#elif defined (__AVR_ATxmega64C3__)
+#  include <avr/iox64c3.h>
 #elif defined (__AVR_ATxmega64D3__)
 #  include <avr/iox64d3.h>
-#elif defined (__AVR_ATxmega128A1__)
-#  include <avr/iox128a1.h>
-#elif defined (__AVR_ATxmega128A1U__)
-#  include <avr/iox128a1u.h>
+#elif defined (__AVR_ATxmega64A1__)
+#  include <avr/iox64a1.h>
+#elif defined (__AVR_ATxmega64B1__)
+#  include <avr/iox64b1.h>
+#elif defined (__AVR_ATxmega128A4__)
+#  include <avr/iox128a4.h>
+#elif defined (__AVR_ATxmega128A4U__)
+#  include <avr/iox128a4u.h>
+#elif defined (__AVR_ATxmega128D4__)
+#  include <avr/iox128d4.h>
 #elif defined (__AVR_ATxmega128A3__)
 #  include <avr/iox128a3.h>
+#elif defined (__AVR_ATxmega128A3U__)
+#  include <avr/iox128a3u.h>
+#elif defined (__AVR_ATxmega128B3__)
+#  include <avr/iox128b3.h>
 #elif defined (__AVR_ATxmega128D3__)
 #  include <avr/iox128d3.h>
 #elif defined (__AVR_ATxmega192A3__)
 #  include <avr/iox192a3.h>
+#elif defined (__AVR_ATxmega192A3U__)
+#  include <avr/iox192a3u.h>
+#elif defined (__AVR_ATxmega192C3__)
+#  include <avr/iox192c3.h>
 #elif defined (__AVR_ATxmega192D3__)
 #  include <avr/iox192d3.h>
 #elif defined (__AVR_ATxmega256A3__)
 #  include <avr/iox256a3.h>
+#elif defined (__AVR_ATxmega256A3U__)
+#  include <avr/iox256a3u.h>
 #elif defined (__AVR_ATxmega256A3B__)
 #  include <avr/iox256a3b.h>
+#elif defined (__AVR_ATxmega256A3BU__)
+#  include <avr/iox256a3bu.h>
+#elif defined (__AVR_ATxmega256C3__)
+#  include <avr/iox256c3.h>
 #elif defined (__AVR_ATxmega256D3__)
 #  include <avr/iox256d3.h>
+#elif defined (__AVR_ATxmega384C3__)
+#  include <avr/iox384c3.h>
+#elif defined (__AVR_ATxmega384D3__)
+#  include <avr/iox384d3.h>
+#elif defined (__AVR_ATxmega128A1__)
+#  include <avr/iox128a1.h>
+#elif defined (__AVR_ATxmega128A1U__)
+#  include <avr/iox128a1u.h>
+#elif defined (__AVR_ATxmega128B1__)
+#  include <avr/iox128b1.h>
 #elif defined (__AVR_ATA6289__)
 #  include <avr/ioa6289.h>
 /* avr1: the following only supported for assembler programs */
diff -urN avr-libc-orig//include/avr/Makefile.am avr-libc//include/avr/Makefile.am
--- avr-libc-orig//include/avr/Makefile.am	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//include/avr/Makefile.am	2012-11-30 17:15:42.000000000 -0800
@@ -190,23 +190,42 @@
     iousb646.h \
     iousb647.h \
     iousbxx6_7.h \
+    iox16a4u.h \
+    iox16d4.h \
+    iox32a4.h \
+    iox32a4u.h \
+    iox32d4.h \
+    iox64a4.h \
+    iox64d4.h \
+    iox64a3.h \
+    iox64a3u.h \
+    iox64b3.h \
+    iox64c3.h \
     iox64d3.h \
-    iox128a1.h \
-    iox128a1u.h \
+    iox64a1.h \
+    iox64b1.h \
+    iox128a4.h \
+    iox128a4u.h \
+    iox128d4.h \
     iox128a3.h \
+    iox128a3u.h \
+    iox128b3.h \
     iox128d3.h \
-    iox16a4.h \
-    iox16d4.h \
     iox192a3.h \
+    iox192a3u.h \
+    iox192c3.h \
     iox192d3.h \
     iox256a3.h \
+    iox256a3u.h \
     iox256a3b.h \
+    iox256a3bu.h \
+    iox256c3.h \
     iox256d3.h \
-    iox32a4.h \
-    iox32d4.h \
-    iox64a1.h \
-    iox64a1u.h \
-    iox64a3.h \
+    iox384c3.h \
+    iox384d3.h \
+    iox128a1.h \
+    iox128a1u.h \
+    iox128b1.h \
     lock.h \
     parity.h \
     pgmspace.h \
diff -urN avr-libc-orig//include/avr/sleep.h avr-libc//include/avr/sleep.h
--- avr-libc-orig//include/avr/sleep.h	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//include/avr/sleep.h	2012-11-30 17:15:41.000000000 -0800
@@ -427,22 +427,42 @@
     } while(0)
 
 #elif defined(__AVR_ATxmega16A4__) \
+|| defined(__AVR_ATxmega16A4U__) \
 || defined(__AVR_ATxmega16D4__) \
 || defined(__AVR_ATxmega32A4__) \
+|| defined(__AVR_ATxmega32A4U__) \
 || defined(__AVR_ATxmega32D4__) \
-|| defined(__AVR_ATxmega64A1__) \
-|| defined(__AVR_ATxmega64A1U__) \
+|| defined(__AVR_ATxmega64A4__) \
+|| defined(__AVR_ATxmega64D4__) \
 || defined(__AVR_ATxmega64A3__) \
+|| defined(__AVR_ATxmega64A3U__) \
+|| defined(__AVR_ATxmega64B3__) \
+|| defined(__AVR_ATxmega64C3__) \
 || defined(__AVR_ATxmega64D3__) \
-|| defined(__AVR_ATxmega128A1__) \
-|| defined(__AVR_ATxmega128A1U__) \
+|| defined(__AVR_ATxmega64A1__) \
+|| defined(__AVR_ATxmega64B1__) \
+|| defined(__AVR_ATxmega128A4__) \
+|| defined(__AVR_ATxmega128A4U__) \
+|| defined(__AVR_ATxmega128D4__) \
 || defined(__AVR_ATxmega128A3__) \
+|| defined(__AVR_ATxmega128A3U__) \
+|| defined(__AVR_ATxmega128B3__) \
 || defined(__AVR_ATxmega128D3__) \
 || defined(__AVR_ATxmega192A3__) \
+|| defined(__AVR_ATxmega192A3U__) \
+|| defined(__AVR_ATxmega192C3__) \
 || defined(__AVR_ATxmega192D3__) \
 || defined(__AVR_ATxmega256A3__) \
+|| defined(__AVR_ATxmega256A3U__) \
+|| defined(__AVR_ATxmega256A3B__) \
+|| defined(__AVR_ATxmega256A3BU__) \
+|| defined(__AVR_ATxmega256C3__) \
 || defined(__AVR_ATxmega256D3__) \
-|| defined(__AVR_ATxmega256A3B__)
+|| defined(__AVR_ATxmega384C3__) \
+|| defined(__AVR_ATxmega384D3__) \
+|| defined(__AVR_ATxmega128A1__) \
+|| defined(__AVR_ATxmega128A1U__) \
+|| defined(__AVR_ATxmega__) \
 
     #define SLEEP_MODE_IDLE         (0)
     #define SLEEP_MODE_PWR_DOWN     (SLEEP_SMODE1_bm)
diff -urN avr-libc-orig//include/avr/wdt.h avr-libc//include/avr/wdt.h
--- avr-libc-orig//include/avr/wdt.h	2012-11-29 16:07:05.000000000 -0800
+++ avr-libc//include/avr/wdt.h	2012-11-30 17:15:42.000000000 -0800
@@ -131,21 +131,42 @@
 
 
 #if defined(__AVR_ATxmega16A4__) \
+|| defined(__AVR_ATxmega16A4U__) \
 || defined(__AVR_ATxmega16D4__) \
 || defined(__AVR_ATxmega32A4__) \
+|| defined(__AVR_ATxmega32A4U__) \
 || defined(__AVR_ATxmega32D4__) \
-|| defined(__AVR_ATxmega64A1U__) \
+|| defined(__AVR_ATxmega64A4__) \
+|| defined(__AVR_ATxmega64D4__) \
 || defined(__AVR_ATxmega64A3__) \
+|| defined(__AVR_ATxmega64A3U__) \
+|| defined(__AVR_ATxmega64B3__) \
+|| defined(__AVR_ATxmega64C3__) \
 || defined(__AVR_ATxmega64D3__) \
-|| defined(__AVR_ATxmega128A1__) \
-|| defined(__AVR_ATxmega128A1U__) \
+|| defined(__AVR_ATxmega64A1__) \
+|| defined(__AVR_ATxmega64B1__) \
+|| defined(__AVR_ATxmega128A4__) \
+|| defined(__AVR_ATxmega128A4U__) \
+|| defined(__AVR_ATxmega128D4__) \
 || defined(__AVR_ATxmega128A3__) \
+|| defined(__AVR_ATxmega128A3U__) \
+|| defined(__AVR_ATxmega128B3__) \
 || defined(__AVR_ATxmega128D3__) \
 || defined(__AVR_ATxmega192A3__) \
+|| defined(__AVR_ATxmega192A3U__) \
+|| defined(__AVR_ATxmega192C3__) \
 || defined(__AVR_ATxmega192D3__) \
 || defined(__AVR_ATxmega256A3__) \
+|| defined(__AVR_ATxmega256A3U__) \
+|| defined(__AVR_ATxmega256A3B__) \
+|| defined(__AVR_ATxmega256A3BU__) \
+|| defined(__AVR_ATxmega256C3__) \
 || defined(__AVR_ATxmega256D3__) \
-|| defined(__AVR_ATxmega256A3B__)
+|| defined(__AVR_ATxmega384C3__) \
+|| defined(__AVR_ATxmega384D3__) \
+|| defined(__AVR_ATxmega128A1__) \
+|| defined(__AVR_ATxmega128A1U__) \
+|| defined(__AVR_ATxmega__)
 
 /*
     wdt_enable(WDT_PER_8KCLK_gc);
